
        .486
        .MODEL  Flat,StdCall
        OPTION  CaseMap:None

;#############################################################################################################

;libraries

        INCLUDELIB kernel32.lib
        INCLUDELIB msvcrt.lib

;#############################################################################################################

;prototypes

GetModuleHandleA   PROTO :DWORD
GetStdHandle       PROTO :DWORD
WriteFile          PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
ReadConsoleInputA  PROTO :DWORD,:DWORD,:DWORD,:DWORD
ExitProcess        PROTO :DWORD
StdOut             PROTO :DWORD

;ANSI function name aliases

GetModuleHandle    TEXTEQU <GetModuleHandleA>
ReadConsoleInput   TEXTEQU <ReadConsoleInputA>

;#############################################################################################################

;equates

STD_INPUT_HANDLE                 EQU -10
STD_OUTPUT_HANDLE                EQU -11
KEY_EVENT                        EQU 1
IMAGE_NUMBEROF_DIRECTORY_ENTRIES EQU 16

;#############################################################################################################

;structure definitions

IMAGE_DOS_HEADER STRUCT
  e_magic          dw ?
  e_cblp           dw ?
  e_cp             dw ?
  e_crlc           dw ?
  e_cparhdr        dw ?
  e_minalloc       dw ?
  e_maxalloc       dw ?
  e_ss             dw ?
  e_sp             dw ?
  e_csum           dw ?
  e_ip             dw ?
  e_cs             dw ?
  e_lfarlc         dw ?
  e_ovno           dw ?
  e_res            dw 4 dup(?)
  e_oemid          dw ?
  e_oeminfo        dw ?
  e_res2           dw 10 dup(?)
  e_lfanew         dd ?
IMAGE_DOS_HEADER ENDS

;----------------------------------------------------

IMAGE_FILE_HEADER    STRUCT
  Machine              dw ?
  NumberOfSections     dw ?
  TimeDateStamp        dd ?
  PointerToSymbolTable dd ?
  NumberOfSymbols      dd ?
  SizeOfOptionalHeader dw ?
  Characteristics      dw ?
IMAGE_FILE_HEADER    ENDS

;----------------------------------------------------

IMAGE_DATA_DIRECTORY STRUCT
  VirtualAddress       dd ?
  isize                dd ?
IMAGE_DATA_DIRECTORY ENDS

;----------------------------------------------------

IMAGE_OPTIONAL_HEADER32     STRUCT
  Magic                       dw ?
  MajorLinkerVersion          db ?
  MinorLinkerVersion          db ?
  SizeOfCode                  dd ?
  SizeOfInitializedData       dd ?
  SizeOfUninitializedData     dd ?
  AddressOfEntryPoint         dd ?
  BaseOfCode                  dd ?
  BaseOfData                  dd ?
  ImageBase                   dd ?
  SectionAlignment            dd ?
  FileAlignment               dd ?
  MajorOperatingSystemVersion dw ?
  MinorOperatingSystemVersion dw ?
  MajorImageVersion           dw ?
  MinorImageVersion           dw ?
  MajorSubsystemVersion       dw ?
  MinorSubsystemVersion       dw ?
  Win32VersionValue           dd ?
  SizeOfImage                 dd ?
  SizeOfHeaders               dd ?
  CheckSum                    dd ?
  Subsystem                   dw ?
  DllCharacteristics          dw ?
  SizeOfStackReserve          dd ?
  SizeOfStackCommit           dd ?
  SizeOfHeapReserve           dd ?
  SizeOfHeapCommit            dd ?
  LoaderFlags                 dd ?
  NumberOfRvaAndSizes         dd ?
  DataDirectory               IMAGE_DATA_DIRECTORY IMAGE_NUMBEROF_DIRECTORY_ENTRIES dup(<>)
IMAGE_OPTIONAL_HEADER32     ENDS

;----------------------------------------------------

IMAGE_NT_HEADERS STRUCT
  Signature        dd ?
  FileHeader       IMAGE_FILE_HEADER <>
  OptionalHeader   IMAGE_OPTIONAL_HEADER32 <>
IMAGE_NT_HEADERS ENDS

;----------------------------------------------------

IMAGE_IMPORT_BY_NAME STRUCT
  Hint                 dw ?
  Name1                db ?
IMAGE_IMPORT_BY_NAME ENDS

;----------------------------------------------------

IMAGE_IMPORT_DESCRIPTOR STRUCT
  UNION
    Characteristics         dd ?
    OriginalFirstThunk      dd ?
  ENDS
  TimeDateStamp           dd ?
  ForwarderChain          dd ?
  Name1                   dd ?
  FirstThunk              dd ?
IMAGE_IMPORT_DESCRIPTOR ENDS

;----------------------------------------------------

COORD STRUCT
  x     dw ?
  y     dw ?
COORD ENDS

;----------------------------------------------------

MOUSE_EVENT_RECORD STRUCT
  dwMousePosition    COORD <>
  dwButtonState      dd ?
  dwControlKeyState  dd ?
  dwEventFlags       dd ?
MOUSE_EVENT_RECORD ENDS

;----------------------------------------------------

KEY_EVENT_RECORD  STRUCT
  bKeyDown          dd ?
  wRepeatCount      dw ?
  wVirtualKeyCode   dw ?
  wVirtualScanCode  dw ?
  UNION
    UnicodeChar       dw ?
    AsciiChar         db ?
  ENDS
  dwControlKeyState dd ?
KEY_EVENT_RECORD  ENDS

;----------------------------------------------------

WINDOW_BUFFER_SIZE_RECORD STRUCT
  dwSize                    COORD <>
WINDOW_BUFFER_SIZE_RECORD ENDS

;----------------------------------------------------

MENU_EVENT_RECORD STRUCT
  dwCommandId       dd ?
MENU_EVENT_RECORD ENDS

;----------------------------------------------------

FOCUS_EVENT_RECORD STRUCT
  bSetFocus          dd ?
FOCUS_EVENT_RECORD ENDS

;----------------------------------------------------

INPUT_RECORD          STRUCT 
  EventType             dw ?
  alignment             db ?,?
  UNION
    KeyEvent              KEY_EVENT_RECORD <>
    MouseEvent            MOUSE_EVENT_RECORD <>
    WindowBufferSizeEvent WINDOW_BUFFER_SIZE_RECORD <>
    MenuEvent             MENU_EVENT_RECORD <>
    FocusEvent            FOCUS_EVENT_RECORD <>
  ENDS 
INPUT_RECORD          ENDS 

;#############################################################################################################

        .CODE

;*************************************************************************************************************

;data

;normally, this stuff would be in a data segment
;however, it is all string constants (never written)
;placing it here eliminates the need for another segment, reducing EXE size

szColon  db ':',0
szAnyKey db 13,10,'Press Any Key to Exit'
szCrLf   db 13,10,0

;*************************************************************************************************************

_main   PROC

        INVOKE  StdOut,offset szCrLf
        INVOKE  GetModuleHandle,0
        mov     ebx,eax
        add     eax,[ebx].IMAGE_DOS_HEADER.e_lfanew
        lea     esi,[eax].IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[1*8]
        mov     eax,[esi].IMAGE_DATA_DIRECTORY.VirtualAddress
        lea     esi,[ebx+eax]

        .WHILE  [esi].IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk
            mov     edi,ebx
            add     edi,[esi].IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk
            .WHILE  DWORD ptr [edi]
                .IF     !(DWORD ptr [edi] & 80000000h)
                    mov     edx,[esi].IMAGE_IMPORT_DESCRIPTOR.Name1
                    add     edx,ebx
                    INVOKE  StdOut,edx
                    INVOKE  StdOut,offset szColon
                    mov     ecx,[edi]
                    and     ecx,7FFFFFFFh
                    lea     edx,[ebx+ecx].IMAGE_IMPORT_BY_NAME.Name1
                    INVOKE  StdOut,edx
                    INVOKE  StdOut,offset szCrLf
                .ENDIF
                lea     edi,[edi+4]
            .ENDW
            lea     esi,[esi+SIZEOF IMAGE_IMPORT_DESCRIPTOR]
        .ENDW

        INVOKE  StdOut,offset szAnyKey
        call    AnyKey
        INVOKE  ExitProcess,0

_main   ENDP

;*************************************************************************************************************

StdOut  PROC    USES EDI lpString:DWORD
;
;Write String to Console Standard Output
;
;Call With: lpSting = address of string to display
;
;  Returns: EAX = number of bytes written
;
;Also Uses: ECX, EDX, all other registers are preserved
;
;----------------------------------------------------

        xor     eax,eax                         ;EAX = 0
        mov     edi,lpString
        push    eax                             ;dwBytesWritten = 0
        mov     edx,edi
        mov     ecx,esp                         ;ECX = ADDR dwBytesWritten
        push    eax                             ;WriteFile:lpOverlapped = NULL
        push    ecx                             ;WriteFile:lpNumberOfBytesWritten
        or      ecx,-1
        repnz   scasb
        or      eax,-2
        sub     eax,ecx
        push    eax                             ;WriteFile:nNumberOfBytesToWrite
        push    edx                             ;WriteFile:lpBuffer
        INVOKE  GetStdHandle,STD_OUTPUT_HANDLE
        push    eax                             ;WriteFile:hFile
        CALL    WriteFile
        pop     eax
        ret

StdOut  ENDP

;*************************************************************************************************************

AnyKey  PROC
;
;Wait for Any Console Key Press - DednDave 12-2011
;
;  This function returns when any console key is pressed (bKeyDown = 1).
;A possible drawback is that all input event records are removed from
;the console input queue until a key is pressed. In many cases, this is
;not an issue. The virtual key code, virtual scan code, TCHAR character,
;and control key state values are returned in registers.

;Call With: Nothing
;
;  Returns: EAX = TCHAR character (high word of EAX = 0)
;           ECX = control key state flags
;               Bit   Name                Meaning
;                0    RIGHT_ALT_PRESSED   Right ALT key is pressed
;                1    LEFT_ALT_PRESSED    Left ALT key is pressed
;                2    RIGHT_CTRL_PRESSED  Right CTRL key is pressed
;                3    LEFT_CTRL_PRESSED   Left CTRL key is pressed
;                4    SHIFT_PRESSED       SHIFT key is pressed
;                5    NUMLOCK_ON          NUM LOCK light is on
;                6    SCROLLLOCK_ON       SCROLL LOCK light is on
;                7    CAPSLOCK_ON         CAPS LOCK light is on
;                8    ENHANCED_KEY        Key is enhanced
;           EDX:
;           low word (DX) = virtual key code
;               high word = virtual scan code
;
;Also Uses: all other registers are preserved
;
;----------------------------------------------------

        push    ebx
        push    ebp
        sub     esp,(sizeof INPUT_RECORD+3) and -4
        mov     ebp,esp
        INVOKE  GetStdHandle,STD_INPUT_HANDLE
        xchg    eax,ebx
        push    ecx

AnyKy0: INVOKE  ReadConsoleInput,ebx,ebp,1,esp
        movzx   edx,word ptr [ebp].INPUT_RECORD.EventType
        cmp     edx,KEY_EVENT                             ;KEY_EVENT EQU 1
        jnz     AnyKy0

        cmp     edx,[ebp].INPUT_RECORD.KeyEvent.bKeyDown
        jnz     AnyKy0

        pop     ecx
        movzx   eax,word ptr [ebp].INPUT_RECORD.KeyEvent.UnicodeChar
        mov     edx,dword ptr [ebp].INPUT_RECORD.KeyEvent.wVirtualKeyCode
        mov     ecx,[ebp].INPUT_RECORD.KeyEvent.dwControlKeyState
        add     esp,(sizeof INPUT_RECORD+3) and -4
        pop     ebp
        pop     ebx
        ret

AnyKey  ENDP

;#############################################################################################################

        END     _main

